Unit IIS3R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTII10_p;

procedure IIS3R(var X :Array of Real; var Y :Array of Real;
                NX :Integer; var BPAR :Array of Real;
                var C :Array of Real; var IERR :Integer);

implementation

procedure IIS3R(var X :Array of Real; var Y :Array of Real;
                NX :Integer; var BPAR :Array of Real;
                var C :Array of Real; var IERR :Integer);
var
NXM1,J,I :Integer;
DXJ,YPPB,PJ,SIXI,DXJP1,YPPA,DXP,DYJP1,DYJ,DX :Real;
const
ZERO :Real = 0.0;
HALF :Real = 0.5;
ONE :Real = 1.0;
TWO :Real = 2.0;
SIX :Real = 6.0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9;
begin
IERR := 0;
NXM1 := NX-1;
if ( NX < 2 ) 
 then goto _6;
if ( NX = 2 ) 
 then goto _2;
DXJ := X[1]-X[0];
YPPB :=DXJ; //EQUIVALENCE
if ( DXJ <= ZERO )
 then goto _7;
DYJ := Y[1]-Y[0];
for J:=2 to NXM1 do
 begin
  DXJP1 := X[J+0]-X[J-1];
  YPPA := DXJP1; //EQUIVALENCE
  if ( DXJP1 <= ZERO )
   then goto _7;
  DYJP1 := Y[J+0]-Y[J-1];
  DXP := DXJ+DXJP1;
  C[0+(J-1)*3] := DXJP1/DXP;
  C[1+(J-1)*3] := ONE-C[0+(J-1)*3];
  C[2+(J-1)*3] := SIX*(DYJP1/DXJP1-DYJ/DXJ)/DXP;
  DXJ := DXJP1;
  YPPB :=DXJ; //EQUIVALENCE
  DYJ := DYJP1;
_1:
 end;
_2:
C[0] := -BPAR[0]*HALF;
C[1] := BPAR[1]*HALF;
if ( NX = 2 ) 
 then goto _4;
for J:=2 to NXM1 do
 begin
  PJ := C[1+(J-1)*3]*C[0+(J-1-1)*3]+TWO;
  SIXI := PJ; //EQUIVALENCE
  C[0+(J-1)*3] := -C[0+(J-1)*3]/PJ;
  C[1+(J-1)*3] := (C[2+(J-1)*3]-C[1+(J-1)*3]*C[1+(J-1-1)*3])/PJ;
_3:
 end;
_4:
YPPB := (BPAR[3]-BPAR[2]*C[1+(NXM1-1)*3])/(BPAR[2]*C[0+(NXM1-1)*3]+
    TWO);
DXJ := YPPB; //EQUIVALENCE
SIXI := ONE/SIX;
PJ := SIXI; //EQUIVALENCE
for I:=1 to NXM1 do
 begin
  J := NX-I;
  YPPA := C[0+(J-1)*3]*YPPB+C[1+(J-1)*3];
  DXJP1 := YPPA; //EQUIVALENCE
  DX := X[J+0]-X[J-1];
  C[2+(J-1)*3] := SIXI*(YPPB-YPPA)/DX;
  C[1+(J-1)*3] := HALF*YPPA;
  C[0+(J-1)*3] := (Y[J+0]-Y[J-1])/DX-(C[1+(J-1)*3]+C[2+(J-1)*3]*DX)*DX;
  YPPB := YPPA;
  DXJ := YPPB; //EQUIVALENCE
_5:
 end;
goto _9;
_6:
IERR := 65;
goto _8;
_7:
IERR := 66;
_8:
UTII10(IERR,3);
_9:
end;

end.
