Unit IIS5R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, IIS3R_p, IIS4R_p, UTII10_p;

procedure IIS5R(var F :Array of Real; var X :Array of Real;
                NX :Integer; var Y :Array of Real;
                NY :Integer; var XL :Array of Real;
                NXL :Integer; var YL :Array of Real; NYL :Integer;
                var FL :Array of Real; var WK :Array of Real;
                var IERR :Integer);

implementation

procedure IIS5R(var F :Array of Real; var X :Array of Real;
                NX :Integer; var Y :Array of Real;
                NY :Integer; var XL :Array of Real;
                NXL :Integer; var YL :Array of Real; NYL :Integer;
                var FL :Array of Real; var WK :Array of Real;
                var IERR :Integer);
var
I,IXL,IY,NXM1,NYM1,KYL,KYLP1,JERR,KYL1,IER1,IYL :Integer;
ZERO,D :Real;
BPAR :Array [0..3] of Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14;
begin
ZERO := 0.0;
IER1 := IERR;
IERR := 0;
JERR := 0;
NXM1 := NX-1;
NYM1 := NY-1;
if ( IER1 = 111111 ) 
 then goto _3;
if ( NX < 2 ) 
 then goto _9;
if ( NY < 2 ) 
 then goto _10;
for I:=1 to NXM1 do
 begin
  D := X[I+0]-X[I-1];
  if ( D <= ZERO ) 
   then goto _11;
_1:
 end;
for I:=1 to NYM1 do
 begin
  D := Y[I+0]-Y[I-1];
  if ( D <= ZERO ) 
   then goto _12;
_2:
 end;
_3:
for I:=1 to 4 do
 begin
  BPAR[I-1] := ZERO;
_4:
 end;
for IY:=1 to NY do
 begin
  IIS3R(X,F[0+(IY-1)*NX],NX,BPAR,WK[0],JERR);
  JERR := 111111;
  IIS4R(X,F[0+(IY-1)*NX],NX,WK[0],XL,FL[0+(IY-1)*NXL],NXL,JERR);
  if ( JERR <> 0 ) 
   then IERR := 1;
_5:
 end;
if ( IERR <> 0 ) 
 then UTII10(IERR,5);
KYL := NYM1*3;
KYLP1 := KYL+1;
for IXL:=1 to NXL do
 begin
  for IY:=1 to NY do
   begin
    KYL1 := KYL+IY;
    WK[KYL1-1] := FL[(IXL-1)+(IY-1)*NXL];
_6:
   end;
  IIS3R(Y,WK[KYLP1-1],NY,BPAR,WK[0],JERR);
  for IYL:=1 to NYL do
   begin
    JERR := 111111;
    IIS4R(Y,WK[KYLP1-1],NY,WK[0],YL[IYL-1],FL[(IXL-1)+(IYL-1)*NXL],1,
         JERR);
    if ( JERR <> 0 ) 
     then IERR := 2;
_7:
   end;
_8:
 end;
if ( IERR = 2 ) 
 then UTII10(IERR,5);
goto _14;
_9:
IERR := 65;
goto _13;
_10:
IERR := 66;
goto _13;
_11:
IERR := 67;
goto _13;
_12:
IERR := 68;
_13:
if ( IER1 = 111111 ) 
 then goto _14;
UTII10(IERR,5);
_14:
end;

end.
